program CCshrink; (* CloseCombat map shrinker *)

       const TABCHAR = #9;
             LFCHAR = #10;
             CRCHAR = #13;

             CCedit = 0; (* LF terminated lines *)
             CC2    = 2; (* CR terminated lines *)
             CC3    = 3; (* CR+LF terminated lines *)

       type string255 = string(.255.);


(* sub-programs *)

       function wort(zeile : string255; position : integer) : string255;
       (* letzte Aenderung: 16.08.1986 *)
       var i,j : integer;
           erg : string255;

       begin
          i:=1;
          for j:=1 to position do
          begin
            while ((zeile[i]=' ') or (zeile[i]=TABCHAR)) and (i <= Length(zeile)) do i:=Succ(i);
            if (i > Length(zeile)) then wort:=''
            else
            begin
              erg:=zeile[i];
              i:=Succ(i);
              while ((zeile[i]<>' ') and (zeile[i]<>TABCHAR)) and (i <= Length(zeile)) do
              begin
                erg:=erg+zeile[i];
                i:=Succ(i);
              end;
              wort:=erg
            end
          end
       end;   (*   wort(..) : string255    *)


       (* Konvert ASCII to Integer and Integer to ASCII *)
       (* letzte Aenderung: 27.07.1986 --- Manfred Fischer *)

       function Atoi(kette : string255) : integer;
       CONST ascii_of_0 = 48;
       VAR i,sign,lager : Integer;

       begin
         lager:=0;
         sign := +1;
         for i:=1 to length(kette) do
           case kette[i] of
             '0'..'9' : lager := (lager*10) + (ord(kette[i])-ascii_of_0);
             '-' : sign := -1;
             else ; (* lager:=(lager*10) + 0 *)
           end;
         Atoi := sign * lager
       end;         (** atoi() **)


       function Itoa(zahl : integer) : string255;
       CONST ascii_of_0 = 48;
       VAR zwisch,rest : integer;
           erg : string255;

       begin
         erg:='';
         zwisch:=abs(zahl);
         repeat
           rest:=(zwisch mod 10);
           zwisch:=(zwisch div 10);
           erg := (chr(ascii_of_0 + rest)) + erg
         until (zwisch < 1);
         if (zahl < 0) then Itoa := '-' + erg
         else Itoa := erg;
       end;


       function RestOfLine(s : string255; delimiter : char) : string255;
       var result : string255;
           i : integer;
       begin
         result := '';
         i := 1;
         while (i <= length(s)) and (s[i] <> delimiter) do i := Succ(i);
         while (i <= length(s)) do
         begin
           result := result + s[i];
           i := Succ(i);
         end;
         RestOfLine := result;    (* includes delimiter! *)
       end;

       procedure ReadLine(var InHandle : text; Format : integer; var s : string255);
       const linelengthlimit = 255;
       var i : integer; c : char; lineend : boolean;
       begin
         (* read the line from file until delimiter is reached, read delimiter *)
         (* and transfer the chars (except the delimiter(s)) to var s *)
         (* i/o-check done ! *)
         i := 0;
         s := '';
         lineend := FALSE;
         repeat;
           lineend := eof(InHandle);
           if not lineend then
           begin
             read(InHandle, c);
             if (c = LFCHAR) then
             begin
               if (Format = 3) or (Format = 0) then lineend := TRUE
             end
             else if (c = CRCHAR) then
             begin
               if (Format = 2) then lineend := TRUE
             end
             else (* valid data *) if (i < linelengthlimit) then
             begin
               i := Succ(i);
               s := s + c;
             end;
           end;
         until lineend;
       end;

       procedure WriteLine(var OutHandle : text; Format : integer; var s : string255);
       begin
         if (Format = 2) then write(OutHandle, s, CRCHAR)
         else write(OutHandle, s, CRCHAR, LFCHAR);
       end;


var s, header, inputfilename, outputfilename : string255;
    informat, outformat : byte;  (* determines CloseCombat format *)

    infile, outfile : Text;      (* file handles *)

    maxx, maxy : integer;        (* dimensions of inputfile *)
    x1, y1, x2, y2 : integer;    (* new range of output file *)

    tilecounter : integer;       (* counts how many lines are written *)
    infileposition : integer;    (* counts how many lines were read *)

begin
   informat := 2; (* CC2 as default *)
   outformat := 2;

   writeln('CCshrink - a CloseCombat map.txt-file shrinker utility by Mafi');
   writeln('written in TurboPascal - sent comments to closecombat2@claranet.de');
   writeln('be carefull - no I/O-checking is done');
   writeln('the input file must reside in the same folder as the program');
   writeln;
   write('which format to use: (CC2 / CC3 / CC4 / CC5) = ');
   readln(s);

   if (s = 'cc2') or (s = 'CC2') or (s = '2') then informat := 2
   else if (s = 'cc3') or (s = 'CC3') or (s = '3') then informat := 3
   else if (s = 'cc4') or (s = 'CC4') or (s = '4') then informat := 4
   else if (s = 'cc5') or (s = 'CC5') or (s = '5') then informat := 5;

   writeln('selected file-format = CloseCombat',informat);
   if (informat = 4) or (informat = 5) then
   begin
     informat := 3;
     writeln('it is equal to CloseCombat',informat,' file format.');
   end;

   if (informat = 2) or (informat = 3) then outformat := informat
   else
   begin
      writeln('sorry, not supported yet. send an example file to Mafi:');
      writeln('closecombat2@claranet.de');
      writeln('so I will implement it!');
      Exit; (* terminate program *)
   end;

   writeln;
   writeln('this little program will shrink the size of a CC-map.txt file');
   writeln('but not the graphics (use a graphics editor instead please),');
   writeln('only the terrain-elements and -elevation definitions are handled.');
   write('the file-type must be ');
   if (informat = 2) then writeln('(internal 41) "Data/Maps/Map###"')
   else if (informat = 3) then writeln('(internal 10) "*****.txt"');
   write('enter input filename: ');

   readln(inputfilename);

   if (informat = 2) then outputfilename := 'MAP-SHR'
   else if (informat = 3) then outputfilename := 'SHRINKED.txt';

   writeln('resulting output will be written into file ',outputfilename);

   Assign(infile, inputfilename);
   Reset(infile); (* open file for input *)
   Assign(outfile, outputfilename);
   Rewrite(outfile); (* create new file for output *)

   (* first: reading and checking the header informations *)

   readln(infile, header);
   if (informat = 2) then
   begin
     if (header(.1.) = '4') and (header(.2.) = '1') then
     begin
       writeln('valid CC2-header found');
       if (length(header) >= 3) then (* perhaps LF terminated *)
       begin
         if (header(.3.) = LFCHAR) then
         begin
           writeln('old CCedit format LF-terminated lines');
           Close(Infile);
           Reset(Infile);
           informat := 0;
           outformat := 2;
           ReadLine(infile, informat, header);
         end
         else
         begin
           Close(infile);
           Reset(infile);
           informat := 2;
           ReadLine(infile, informat, header);
         end
       end
       else
       begin
         Close(infile);
         Reset(infile);
         informat := 2;
         ReadLine(infile, informat, header);
       end;
       WriteLine(outfile, outformat, header);
     end
     else
     begin
       writeln('aborting: no CC2-header: ', header);
       Close(infile);
       Close(outfile);
       Exit;
     end
   end
   else if (informat = 3) then
   begin
     if (header(.1.) = '1') and (header(.2.) = '0') then
     begin
       writeln('valid CC3-header found');
       Close(infile);
       Reset(infile);
       ReadLine(infile, informat, header);
       WriteLine(outfile, outformat, header);
       ReadLine(infile, informat, s);  (* reading and writing second (blank?) line *)
       WriteLine(outfile, outformat, s);
     end
     else
     begin
       writeln('aborting: no CC3-header: ', header);
       Close(infile);
       Close(outfile);
       Exit;
     end
   end;

   (* second: determining the size of the input file datas *)
   (* valid for all file formats *)

   ReadLine(infile, informat, s); (* maxx *)
   maxx := atoi(wort(s,1));
   ReadLine(infile, informat, s); (* maxy *)
   maxy := atoi(wort(s,1));

   writeln;
   writeln('input file dimensions: Maxx=',maxx,'  Maxy=',maxy);
   write('is it correct ? (yes / no) : ');
   readln(s);
   if (s(.1.) = 'n') or (s(.1.) = 'N') then
   begin
     writeln('user abort');
     Close(infile);
     Close(outfile);
     Exit;
   end;

   (* third: asking for new dimensions of the map *)

   writeln;
   writeln('now you must enter the new dimensions of the map!');
   writeln('it is counted in elevation tiles (1 elevation tile = 4x4 terrain tiles)');
   writeln('                                 (1 elevation tile = 40x40 pixels)');
   writeln('                                 (1 elevation tile = one line in file)');
   writeln('horizontal dimensions of input file are x1=',1,' x2=',maxx,' elevation tiles');

   repeat
     writeln('new horizontal dimensions x1 < x2 (counted from 1)');
     write('new range x1=');
     readln(x1);
     write('new range x2=');
     readln(x2);
   until (x1 < x2) and (x1 > 0) and (x2 <= maxx);

   writeln('vertical dimensions of input file are y1=',1,' y2=',maxy,' elevation tiles');

   repeat
     writeln('new vertical dimensions y1 < y2 (counted from 1)');
     write('new range y1=');
     readln(y1);
     write('new range y2=');
     readln(y2);
   until (y1 < y2) and (y1 > 0) and (y2 <= maxy);

   writeln;
   writeln('now converting from 1-',maxx,'x1-',maxy,' to ',x1,'-',x2,'x',y1,'-',y2);

   (* forth: writing the data sizes to output file *)
   (* valid for all file formats *)

   write(outfile, (x2 - x1 + 1), ' X Max');
   s := '';
   WriteLine(outfile, outformat, s);
   write(outfile, (y2 - y1 + 1), ' Y Max');
   WriteLine(outfile, outformat, s);

   (* fifth: reading the next comment lines *)
   (* valid for all file formats: searching for the line "&" *)

   repeat
     write('*');
     ReadLine(infile, informat, s);
     WriteLine(outfile, outformat, s);
   until (s(.1.) = '&');

   (* sixth: reading the data lines and writing them if they fit *)
   (*        including the change of the numbering in first column *)
   (* valid for all file formats: searching for the end-line "#" *)

   tilecounter := 0;
   repeat
     ReadLine(infile, informat, s);
     if (s(.1.) = '#') then (* end of datas *)
     begin
       WriteLine(outfile, outformat, s);
       if (not eof(infile)) then
       begin
         writeln('additional datas behind first "#" found, will be written without change');
         if (outformat = 2) then writeln('perhaps this are Bridg###-file informations!!');
       end;

       while not eof(infile) do
       begin
         ReadLine(infile, informat, s);
         WriteLine(outfile, outformat, s);
       end;
       write('end of input file...');
     end
     else                    (* valid datas *)
     begin
       infileposition := atoi(wort(s, 1));
       if (infileposition >= ((y1 - 1) * maxx))
       and (infileposition < (y2 * maxx))
       then
       begin
         if ((infileposition MOD maxx) >= (x1 - 1))
         and ((infileposition MOD maxx) <= (x2 - 1)) then
         begin
           write(outfile, tilecounter);
           s := RestOfLine(s, TABCHAR);
           WriteLine(outfile, outformat, s);
           tilecounter := Succ(tilecounter);
         end;
       end;
     end;
   until eof(infile);
   Close(infile);
   Close(outfile);
   writeln('job done, result in ', outputfilename);
   writeln(Succ(x2 - x1)*Succ(y2 - y1),' tiles expected, ',tilecounter,' tiles written.');
   writeln('cut-off from the graphics:');
   writeln('at the top   = ',(y1 - 1) * 40,' pixels,');
   writeln('at the left  = ',(x1 - 1) * 40,' pixels,');
   writeln('at the rigth = ',(maxx - x2) * 40,' pixels,');
   writeln('at the bottom= ',(maxy - y2) * 40,' pixels.');
end.


